select
  an.numero
  , coalesce (el.dtmedida, ecc.dtmedida) as Data_Exame
  , el.valor as Escore_Locomocao
  , ecc.valor as ECC
  , (el.dtmedida - lac.dtinicio) as Dias_Lactacao
  , lei.pesototal as Ult_Cont_Leite
from
  animal an
  left join medida el on
    el.cdanimal = an.cdanimal
    and el.cdtipomedida = 1037
  left join medida ecc on
    ecc.cdanimal = an.cdanimal
    and ecc.dtmedida = el.dtmedida
    and ecc.cdtipomedida = 2
  left join lactacao lac on lac.cdlactacao =
    (select first 1 re.cdlactacao
    from lactacao re
    where re.cdanimal = an.cdanimal
      and re.dtinicio <= coalesce (el.dtmedida,  ecc.dtmedida)
      and ((re.dtfim >= coalesce (el.dtmedida,  ecc.dtmedida))
        or (re.dtfim is null))
    order by re.dtinicio desc)
  left join leite lei on lei.cdleite =
    (select first 1 rea.cdleite
    from leite rea
    where rea.cdlactacao = lac.cdlactacao
      and rea.dtleite <= coalesce (el.dtmedida,  ecc.dtmedida)
    order by rea.dtleite desc)
where
    ((el.dtmedida is not null) or (ecc.dtmedida is not null))

union

select
  an.numero
  , coalesce (el.dtmedida, ecc.dtmedida) as Data_Exame
  , el.valor as Escore_Locomocao
  , ecc.valor as ECC
  , (el.dtmedida - lac.dtinicio) as Dias_Lactacao
  , lei.pesototal as Ult_Cont_Leite
from
  animal an
  left join medida el on
    el.cdanimal = an.cdanimal
    and el.dtmedida = '1900-01-01'
    and el.cdtipomedida = 1037
  left join medida ecc on
    ecc.cdanimal = an.cdanimal
    and not exists (select * from medida where cdanimal = ecc.cdanimal and dtmedida = ecc.dtmedida and cdtipomedida = 1037)
    and ecc.cdtipomedida = 2
  left join lactacao lac on lac.cdlactacao =
    (select first 1 re.cdlactacao
    from lactacao re
    where re.cdanimal = an.cdanimal
      and re.dtinicio <= coalesce (el.dtmedida,  ecc.dtmedida)
      and ((re.dtfim >= coalesce (el.dtmedida,  ecc.dtmedida))
        or (re.dtfim is null))
    order by re.dtinicio desc)
  left join leite lei on lei.cdleite =
    (select first 1 rea.cdleite
    from leite rea
    where rea.cdlactacao = lac.cdlactacao
      and rea.dtleite <= coalesce (el.dtmedida,  ecc.dtmedida)
    order by rea.dtleite desc)
where
    ((el.dtmedida is not null) or (ecc.dtmedida is not null))
